program fractalisecarte;

{$N+,E-,I-}

const
  degre = 3.14159265358979323846264338327950288419716939937510/180;

var
  inf,outf : text;
  precis : word;
  decal : extended;
  dist : extended;
  latb0,latb1,latb2,latb3,lonb0,lonb1,lonb2,lonb3 : extended;
  t,t1,t2,t3,t4,t5,t6,lt,lt1,lt2,lt3 : extended;
  s,s1,s2,s3 : string;
  i,j,k,l : longint;
  index : byte;
  code : integer;
  io : word;
  tout : boolean;
  debut,fin : word;

const
  maxpoints = 1000;

var
  nbpoints : word;
  points : array[0..maxpoints-1] of record
    lat,lon : double;
  end;
  otyp : byte;
  onom : string;

function trueint(t : extended) : extended;
begin
  if t>=0 then trueint := trunc(t)
    else trueint := trunc(t)-1;
end;

procedure erreur(s : string);
begin
  writeln(s);
  halt(1);
end;

procedure premier(s : string;var s1 : string;var ind : byte);
begin
  s1 := '';
  ind := 1;
  while (ind<=length(s)) and (s[ind]=' ') do inc(ind);
  while (ind<=length(s)) and (s[ind]<>' ') do
    begin s1 := s1+s[ind]; inc(ind); end;
  while (ind<=length(s)) and (s[ind]=' ') do inc(ind);
end;

function distance(lat1,lon1,lat2,lon2 : extended) : extended;
var
  t : extended;
begin
  t := sin(lat1*degre)*sin(lat2*degre)
    + cos(lat1*degre)*cos(lat2*degre)*cos((lon1-lon2)*degre);
  distance := sqrt(2*(1-t))/degre;
end;

procedure bezier(x_1,x0,x1,x2 : extended;var b0,b1,b2,b3 : extended);
var
  u0,u1 : extended;
begin
  while x1-x0>180 do x1 := x1-360;
  while x1-x0<-180 do x1 := x1+360;
  while x2-x0>180 do x2 := x2-360;
  while x2-x0<-180 do x2 := x2+360;
  while x_1-x0>180 do x_1 := x_1-360;
  while x_1-x0<-180 do x_1 := x_1+360;
  u0 := (x1-x_1)/2;
  u1 := (x2-x0)/2;
  b0 := x0;
  b1 := u0;
  b2 := 3*(x1-x0)-2*u0-u1;
  b3 := (u0+u1)-2*(x1-x0);
end;

function atraiter(n : word) : boolean;
begin
  if tout then begin
    atraiter := true;
    exit;
  end;
  if debut<=fin then atraiter := (n>=debut) and (n<fin)
  else atraiter := (n>=debut) or (n<fin);
end;

begin
  decal := 0.35;
  assign(inf,'ANECBAS.DAT');
  reset(inf);
  assign(outf,'ANECTRT.DAT');
  rewrite(outf);
  while not eof(inf) do begin
    readln(inf,s);
    io := ioresult;
    if io<>0 then erreur('Erreur E/S');
    if s='' then erreur('Erreur: ligne blanche');
    premier(s,s1,index);
    if s1='@VILLE' then otyp := 1
    else if s1='@RIVIERE' then otyp := 2
    else if s1='@COTE' then otyp := 3
    else if s1='@FORET' then otyp := 4
    else if s1='@MONTAGNES' then otyp := 5
    else if s1='@DESERT' then otyp := 6
    else erreur('Instruction inconnue: '+s1);
    writeln(outf,s);
    onom := '';
    nbpoints := 0;
    tout := false;
    debut := 0;
    fin := 0;
    repeat
      if eof(inf) then erreur('Fin de fichier inattendue');
      readln(inf,s);
      io := ioresult;
      if io<>0 then erreur('Erreur E/S');
      premier(s,s1,index);
      if s1='@NOM' then begin
        s2 := copy(s,index,length(s)-index+1);
        if s2[1]<>'"' then erreur('Erreur dans la chane: '+s2);
        i := 2;
        onom := '';
        while (i<=length(s2)) and (s2[i]<>'"') do begin
          onom := onom+s2[i];
          inc(i);
        end;
        if i>length(s2) then erreur('Erreur dans la chane: '+s2);
        writeln(outf,s);
      end else if s1='@MARQUEUR' then
      else if s1='@COMMENTAIRE' then
      else if s1='' then erreur('Erreur: ligne blanche')
      else if s1='@STOP' then
      else if s1='&&&TOUT' then tout := true
      else if s1='&&&DEBUT' then debut := nbpoints
      else if s1='&&&FIN' then fin := nbpoints
      else if s1[1]='@' then erreur('Instruction inconnue: '+s1)
      else if s1[1]='[' then begin
        i := 2;
        s2 := '';
        while (i<=length(s1)) and (s1[i]<>';') and (s1[i]<>']') do begin
          s2 := s2+s1[i];
          inc(i);
        end;
        if (i>length(s1)) or (s2[i]=']') then erreur('Erreur de syntaxe');
        inc(i);
        s3 := '';
        while (i<=length(s1)) and (s1[i]<>';') and (s1[i]<>']') do begin
          s3 := s3+s1[i];
          inc(i);
        end;
        if (i>length(s1)) or (s2[i]=';') then erreur('Erreur de syntaxe');
        val(s2,points[nbpoints].lat,code);
        if code<>0 then erreur('Erreur de format numrique');
        val(s3,points[nbpoints].lon,code);
        if code<>0 then erreur('Erreur de format numrique');
        inc(nbpoints);
        if nbpoints>=maxpoints then erreur('Trop de points dans l''objet');
      end else erreur('Erreur de syntaxe');
      if (otyp=1) and (nbpoints>1) then erreur('@STOP attendu');
    until s1='@STOP';
    if otyp=1 then begin
      writeln(outf,'[',points[0].lat:1:5,';',points[0].lon:1:5,']');
      writeln(outf,'@STOP');
    end else begin
      for i := 0 to nbpoints-1 do begin
        if not atraiter(i) then begin
          writeln(outf,'[',points[i].lat:1:5,';',points[i].lon:1:5,']');
        end else begin
          if (otyp=2) and (i=0) then begin
            bezier(points[0].lat,points[0].lat,points[1].lat,points[2].lat,
              latb0,latb1,latb2,latb3);
            bezier(points[0].lon,points[0].lon,points[1].lon,points[2].lon,
              lonb0,lonb1,lonb2,lonb3);
            dist := distance(points[0].lat,points[0].lon,
              points[1].lat,points[1].lon);
          end else if (otyp=2) and (i=nbpoints-2) then begin
            bezier(points[i-1].lat,points[i].lat,points[i+1].lat,points[i+1].lat,
              latb0,latb1,latb2,latb3);
            bezier(points[i-1].lon,points[i].lon,points[i+1].lon,points[i+1].lon,
              lonb0,lonb1,lonb2,lonb3);
            dist := distance(points[i].lat,points[i].lon,
              points[i+1].lat,points[i+1].lon);
          end else if (otyp=2) and (i=nbpoints-1) then begin
            bezier(points[i].lat,points[i].lat,points[i].lat,points[i].lat,
              latb0,latb1,latb2,latb3);
            bezier(points[i].lon,points[i].lon,points[i].lon,points[i].lon,
              lonb0,lonb1,lonb2,lonb3);
            dist := 0;
          end else begin
            bezier(points[(i+nbpoints-1) mod nbpoints].lat,
              points[i].lat,
              points[(i+1) mod nbpoints].lat,
              points[(i+2) mod nbpoints].lat,latb0,latb1,latb2,latb3);
            bezier(points[(i+nbpoints-1) mod nbpoints].lon,
              points[i].lon,
              points[(i+1) mod nbpoints].lon,
              points[(i+2) mod nbpoints].lon,lonb0,lonb1,lonb2,lonb3);
            dist := distance(points[i].lat,points[i].lon,
              points[(i+1) mod nbpoints].lat,points[(i+1) mod nbpoints].lon);
          end;
          precis := trunc(dist*1.2)+1;
          for j := 0 to precis-1 do begin
            t := j/precis;
            t1 := latb0+latb1*t+latb2*t*t+latb3*t*t*t;
            t2 := lonb0+lonb1*t+lonb2*t*t+lonb3*t*t*t;
            if j>0 then begin
              t1 := t1+decal*(random+1)/2;
              t2 := t2+decal*(random+1)/2;
            end;
            t1 := t1-180*trueint((t1+90)/180);
            t2 := t2-360*trueint((t2+180)/360);
            writeln(outf,'[',t1:1:5,';',t2:1:5,']');
          end;
        end;
      end;
      writeln(outf,'@STOP');
    end;
  end;
  close(outf);
  close(inf);
end.