program litcarte;

{$N+,E-,I-}

uses
  crt;

var
  io : word;
  f : text;
  i,j,k,l : longint;
  ch : char;
  typ,mode : byte;
  nom : string;
  stop : boolean;
  lat,lon,lat0,lon0 : extended;
  t,t1,t2,t3,t4,t5,t6 : extended;

const
  chiffres : array[0..9] of char = '0123456789';

function trueint(t : extended) : extended;
begin
  if t>=0 then trueint := trunc(t)
    else trueint := trunc(t)-1;
end;

function latdesc(lat : extended) : string;
var
  t : extended;
  i : longint;
  s : string;
begin
  if lat<0 then begin t := -lat; s := 'S'; end else begin t := lat; s := 'N'; end;
  i := trunc(t*60+1E-9);
  s := ' '+chiffres[i div 600]+chiffres[i div 60 mod 10]+''
    +chiffres[i div 10 mod 6]+chiffres[i mod 10]+''''+s;
  latdesc := s;
end;

function londesc(lon : extended) : string;
var
  t : extended;
  i : longint;
  s : string;
begin
  if lon<0 then begin t := -lon; s := 'W'; end else begin t := lon; s := 'E'; end;
  i := trunc(t*60+1E-9);
  s := chiffres[i div 6000]+chiffres[i div 600 mod 10]+chiffres[i div 60 mod 10]+''
    +chiffres[i div 10 mod 6]+chiffres[i mod 10]+''''+s;
  londesc := s;
end;

function lisnum(spe : boolean;var t : extended) : boolean;
var
  s : string[15];
  code : integer;
  i : byte;
  u,v : extended;
begin
  readln(s);
  io := ioresult;
  if io<>0 then begin
    lisnum := true;
    exit;
  end;
  val(s,t,code);
  if code=0 then begin
    lisnum := false;
    exit;
  end;
  lisnum := true;
  for i := 1 to length(s) do s[i] := upcase(s[i]);
  if s[1]='\' then begin
    if s='\STOP' then stop := true
    else if (s='\MARQUEUR') and spe then begin
      gotoxy(1,9);
      clreol;
      write('Quel marqueur? ');
      readln(s);
      writeln(f,'@MARQUEUR "',s,'"');
      gotoxy(1,9);
      clreol;
    end else if (s='\REFERENCE') and spe then begin
      gotoxy(1,9);
      clreol;
      write('Rfrence: ':20,'Latitude: ':15);
      if lisnum(false,u) then begin gotoxy(1,9); clreol; exit; end;
      gotoxy(51,9);
      write('Longitude: ':15);
      if lisnum(false,v) then begin gotoxy(1,9); clreol; exit; end;
      lat0 := u-180*trueint((u+90)/180);
      lon0 := v-360*trueint((v+180)/360);
      gotoxy(1,9);
      clreol;
    end else if (s='\DIRECTE') and spe then mode := 1
    else if (s='\LOCALE') and spe then mode := 2
    else if (s='\GLOBALE') and spe then mode := 3;
  end;
end;

procedure saisie;
label
  l_0;
begin
  l_0:
  if stop then exit;
  gotoxy(1,4);
  if mode=1 then begin
    clreol;
    writeln('Saisie directe');
    clreol;
    write('Latitude: ':20,'Degr: ':15);
    if lisnum(true,t1) then goto l_0;
    gotoxy(51,5);
    write('Minute: ':15);
    if lisnum(true,t2) then goto l_0;
    gotoxy(1,6);
    clreol;
    write('Longitude: ':20,'Degr: ':15);
    if lisnum(true,t3) then goto l_0;
    gotoxy(51,6);
    write('Minute: ':15);
    if lisnum(true,t4) then goto l_0;
    lat := t1+t2/60;
    lon := t3+t4/60;
  end else if mode=2 then begin
    clreol;
    writeln('Saisie sur carte locale');
    clreol;
    writeln('Rfrence: ':20,latdesc(lat0),';',londesc(lon0));
    clreol;
    write('Dplacement x (cm): ');
    if lisnum(true,t1) then goto l_0;
    gotoxy(1,7);
    clreol;
    write('Dplacement y (cm): ');
    if lisnum(true,t2) then goto l_0;
    lat := lat0+t2*5/3;
    lon := lon0+t1*6.717617139/3;
  end else if mode=3 then begin
    clreol;
    writeln('Saisie sur carte globale');
    clreol;
    writeln('Rfrence: ':20,latdesc(lat0),';',londesc(lon0));
    clreol;
    write('Dplacement x (cm): ');
    if lisnum(true,t1) then goto l_0;
    gotoxy(1,7);
    clreol;
    write('Dplacement y (cm): ');
    if lisnum(true,t2) then goto l_0;
    lat := lat0+t2*10;
    lon := lon0+t1*10;
  end;
  lat := lat-180*trueint((lat+90)/180);
  lon := lon-360*trueint((lon+180)/360);
  gotoxy(1,10);
  clreol;
  writeln('Point saisi: ':20,latdesc(lat),';',londesc(lon));
  write('Correct? ');
  repeat
    ch := upcase(readkey);
  until (ch='O') or (ch='N');
  writeln(ch);
  if ch='N' then goto l_0;
  gotoxy(1,11);
  clreol;
end;

begin
  assign(f,'ANECDAR.DAT');
  append(f);
  io := ioresult;
  if io<>0 then begin
    rewrite(f);
  end;
  textattr := $1F;
  clrscr;
  mode := 1;
  lat0 := 0;
  lon0 := 0;
  repeat
    clrscr;
    write('Crer quoi (Ville, Rivire, Cte, Fort, Montagnes, Dsert, Quitter)? ');
    repeat
      ch := upcase(readkey);
    until (ch='V') or (ch='R') or (ch='C') or (ch='F') or (ch='M') or (ch='D') or (ch='Q');
    writeln(ch);
    if ch='Q' then begin
      close(f);
      clrscr;
      halt;
    end;
    case ch of
      'V' : typ := 1;
      'R' : typ := 2;
      'C' : typ := 3;
      'F' : typ := 4;
      'M' : typ := 5;
      'D' : typ := 6;
    end;
    case typ of
      1 : writeln(f,'@VILLE');
      2 : writeln(f,'@RIVIERE');
      3 : writeln(f,'@COTE');
      4 : writeln(f,'@FORET');
      5 : writeln(f,'@MONTAGNES');
      6 : writeln(f,'@DESERT');
    end;
    write('Nom de l''objet: ');
    readln(nom);
    writeln(f,'@NOM "',nom,'"');
    stop := false;
    repeat
      saisie;
      if not stop then writeln(f,'[',lat:1:5,';',lon:1:5,']');
      if typ=1 then stop := true;
    until stop;
    writeln(f,'@STOP');
  until false;
end.